{

Copyright (c) 2014-2015, Fernando Biazi Nascimento
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of any organization.

}
unit FBNVersionInfo;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, versionresource;

type

  { TFBNVersionInfo }

  TFBNVersionInfo = class(TVersionResource)
  private
    function GetBuild: Word;
    function GetComments: String;
    function GetCompanyName: String;
    function GetFileDescription: String;
    function GetFileVersion: String;
    function GetInternalName: String;
    function GetLegalCopyright: String;
    function GetLegalTradeMarks: String;
    function GetFMajorVersion: Word;
    function GetMinorVersion: Word;
    function GetOriginalFilename: String;
    function GetProductName: String;
    function GetProductVersion: String;
    function GetRelease: Word;
    { private declarations }
  protected
    { protected declarations }
  public
    { public declarations }
    property Build: Word read GetBuild;
    property Comments: String read GetComments;
    property CompanyName: String read GetCompanyName;
    property FileDescription: String read GetFileDescription;
    property FileVersion: String read GetFileVersion;
    property InternalName: String read GetInternalName;
    property LegalCopyright: String read GetLegalCopyright;
    property LegalTradeMarks: String read GetLegalTradeMarks;
    property MajorVersion: Word read GetFMajorVersion;
    property MinorVersion: Word read GetMinorVersion;
    property OriginalFilename: String read GetOriginalFilename;
    property ProductName: String read GetProductName;
    property ProductVersion: String read GetProductVersion;
    property Release: Word read GetRelease;
  published
    { published declarations }
  end;

implementation

{ TFBNVersionInfo }

function TFBNVersionInfo.GetBuild: Word;
begin
  Result := FixedInfo.FileVersion[3];
end;

function TFBNVersionInfo.GetComments: String;
begin
  Result := StringFileInfo[0].Values['Comments'];
end;

function TFBNVersionInfo.GetCompanyName: String;
begin
  Result := StringFileInfo[0].Values['CompanyName'];
end;

function TFBNVersionInfo.GetFileDescription: String;
begin
  Result := StringFileInfo[0].Values['FileDescription'];
end;

function TFBNVersionInfo.GetFileVersion: String;
begin
  Result := StringFileInfo[0].Values['FileVersion'];
end;

function TFBNVersionInfo.GetInternalName: String;
begin
  Result := StringFileInfo[0].Values['InternalName'];
end;

function TFBNVersionInfo.GetLegalCopyright: String;
begin
  Result := StringFileInfo[0].Values['LegalCopyright'];
end;

function TFBNVersionInfo.GetLegalTradeMarks: String;
begin
  Result := StringFileInfo[0].Values['LegalTradeMarks'];
end;

function TFBNVersionInfo.GetFMajorVersion: Word;
begin
  Result := FixedInfo.FileVersion[0];
end;

function TFBNVersionInfo.GetMinorVersion: Word;
begin
  Result := FixedInfo.FileVersion[1];
end;

function TFBNVersionInfo.GetOriginalFilename: String;
begin
  Result := StringFileInfo[0].Values['OriginalFileName'];
end;

function TFBNVersionInfo.GetProductName: String;
begin
  Result := StringFileInfo[0].Values['ProductName'];
end;

function TFBNVersionInfo.GetProductVersion: String;
begin
  Result := StringFileInfo[0].Values['ProductVersion'];
end;

function TFBNVersionInfo.GetRelease: Word;
begin
  Result := FixedInfo.FileVersion[2];
end;

end.

